package org.netkernel.layer1.endpoint;

import org.netkernel.layer0.nkf.*;
import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.urii.SimpleIdentifierImpl;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.urii.IIdentifier;

public class StringToPrimitive extends StandardTransreptorImpl
{
	public StringToPrimitive()
	{	this.declareThreadSafe();
		this.declareFromRepresentation(String.class);
		this.declareFromRepresentation(IBinaryStreamRepresentation.class);
		this.declareToRepresentation(IIdentifier.class);
		this.declareToRepresentation(Byte.class);
		this.declareToRepresentation(Short.class);
		this.declareToRepresentation(Integer.class);
		this.declareToRepresentation(Long.class);
		this.declareToRepresentation(Float.class);
		this.declareToRepresentation(Double.class);
		this.declareToRepresentation(Boolean.class);
	}
		
	public void onTransrept(INKFRequestContext aContext) throws NKFException, NumberFormatException
	{	String in = aContext.sourcePrimary(String.class);
		Class c=aContext.getThisRequest().getRepresentationClass();
		Object result=null;
		if(c == IIdentifier.class)
		{	result=new SimpleIdentifierImpl(in);
		}
		else if(c == Byte.class )
		{	result = Byte.parseByte(in);
		}
		else if(c == Short.class )
		{	result = Short.parseShort(in);
		}
		if(c == Integer.class )
		{	result = Integer.parseInt(in);
		}
		else if(c == Long.class )
		{	result = Long.parseLong(in);
		}
		else if(c == Float.class )
		{	result = Float.parseFloat(in);
		}
		else if(c == Double.class )
		{	result = Double.parseDouble(in);
		}
		else if(c == Boolean.class)
		{	result = Boolean.parseBoolean(in) ? Boolean.TRUE : Boolean.FALSE;			
		}
		aContext.createResponseFrom(result);
	}
}