package org.netkernel.layer1.endpoint.hds;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class FromHDSNodeList extends StandardTransreptorImpl
{
	public FromHDSNodeList()
	{	declareFromRepresentation(IHDSNodeList.class);
	}
	
	@Override
	public void onTransrept(INKFRequestContext aContext) throws Exception
	{
		IHDSNodeList nodelist=aContext.sourcePrimary(IHDSNodeList.class);
		Class requestedRep=aContext.getThisRequest().getRepresentationClass();
		Object result;
		if (requestedRep==IHDSNodeList.class)
		{	result=nodelist;
		}
		else if (requestedRep==IHDSNode.class)
		{	result=getOnlyNode(nodelist,aContext);
		}
		if (requestedRep==Boolean.class)
		{	if (nodelist.size()==1)
			{	Object o=getOnlyNode(nodelist,aContext).getValue();
				if (o instanceof Boolean)
				{	result=(Boolean)o;
				}
				else
				{	result=Boolean.TRUE;
				}
			}
			else
			{	result=nodelist.size()>0;
			}
		}
		else
		{	if (requestedRep==Object.class && nodelist.size()!=1)
			{	result=nodelist;
			}
			else
			{	result=getOnlyNode(nodelist,aContext).getValue();
			}
		}
		aContext.createResponseFrom(result);
	}
	
	private static IHDSNode getOnlyNode(IHDSNodeList aList, INKFRequestContext aContext) throws Exception
	{	int s=aList.size();
		if (s==1)
		{	return aList.getFirstNode();
		}
		else if (s==0) 
		{	throw aContext.createFormattedException("EX_HDSXPATH_NONE", null, null, null, null);
		}
		else
		{	throw aContext.createFormattedException("EX_HDSXPATH_MANY", null, null, null, null);
		}
	}		
}
